/********************************************************************/
/*			   Halo Animation eXporter script by Tanasoo	 	    */
/*			 	Compatible with 3ds max 5+ and Gmax 1.2				*/
/*						Current Version: 1.2B						*/
/********************************************************************/
/*					  Instalation instructions:						*/
/*	1)Place "Halo_Anim_eXporter.mcr" in the 3ds max (or Gmax) root  */
/*	  Directory \ui\macroscripts									*/
/*	2)Lanuch 3DS max (or Gmax, duh ;)) Then click "Customize>		*/
/*	  Customize User Interface" Then Click the "Toobars" tab and 	*/
/*	  from the "Category" drop down list select "HAX" Now from the 	*/
/*	  list, just drag "Halo Animation eXporter" to any toolbar you 	*/
/*	  like, Hit the button and enjoy!								*/
/********************************************************************/
/*							Instructions:							*/
/*	This script will export nodes with both "frame" and "Bip01"		*/
/*	prefixes. It will ignore anything that is not liked to the frame*/
/*	and any object starting with "#" linked to the bones. 			*/
/*	***Make sure to un-link or delete any nodes that do not start 	*/
/*	with "#" form the parent Frame before exporting!!!***			*/
/*																	*/
/*	1)Delete any objects (including skinned mesh) as stated above	*/
/*	2)Enter desired Node List Checksum. This can be found in the 	*/
/*	.gbxmodel tag in Guerilla (near the bottom)						*/
/*	3) Select export mode. (File only works with 3DS MAX)			*/
/*	4)Hit Export!													*/
/********************************************************************/
/* If you have any Questions, Comments, or Bugs Feel free to share !*/
/* Just go to the thread for this script at www.halomods.com or 	*/
/* Email me mailto:mattr@regandesigns.com							*/
/********************************************************************/
/* 					Copyright 2007 Matt Regan						*/
/********************************************************************/
/* 						  Revision History							*/
/*	1.1B	-Fixed StopCheck bug that halted export on some versions*/
/*	of 3DS Max.														*/
/*	-Fixed "Exploding biped" bug that was caused by large/ complex 	*/
/*	Heirarchies														*/
/*	1.2B	- Rebuilt (again) process for finding child, and sibling*/
/*	indexes, it's allot better, and faster now :)							*/										
/********************************************************************/
 
macroScript HEKAnimEX
	category:"HAX"
	tooltip:"Halo Animation eXporter"
(--Start of script

File_Out = ""
NodeArray = #()
SelectedNodes = #()
ParentArray = #()
TempChildren = #()
FirstChildIndexes = #()
NextSiblingIndexes = #()
NumNodes = 0
CurrentNode = 1
NLCheckSum = ""
NodePath = ""
NumFrames = (animationRange.end +1) as string
NumFrames = trimright NumFrames "f"
NumFrames = execute Numframes --haha! converted to int for later use!
StopCheck = 0

fn WriteHeader =(
format "%\n" 16392 to:File_Out
format "%\n" NumFrames to:File_Out
format "%\n" 30 to:File_Out
format "%\n" 1 to:File_Out
format "%\n" "unnamedActor" to:File_Out
format "%\n" NumNodes to:File_Out
format "%\n" NLCheckSum to:File_Out
)-- end write header

fn WriteHierarchy = (
	CurrentNode = 1
	for n = 1 to NumNodes do (
		NodePath = getNodeByName NodeArray[n]
		Select NodePath
		format "%\n" $.name to:File_Out
		format "%\n" FirstChildIndexes[n] to:File_Out
		format "%\n" NextSiblingIndexes[n] to:File_Out

	)--End for loop
)-- End fn WriteHierarchy

fn WriteAnimation = (
	sliderTime = 0f
	for f = 1 to numFrames do(
		for n = 1 to numNodes do(
			NodePath = getNodeByName NodeArray[n]
			Select NodePath
			if n == 1 then (
				in coordsys parent NodeRot = $.rotation
				NodeRotN = normalize (quat -NodeRot.x -NodeRot.y -NodeRot.z NodeRot.w)
				format "%\t%\t%\n" $.Pos.X $.Pos.Y $.Pos.Z to:File_Out
				format "%\t%\t%\t%\n" NodeRotN.x NodeRotN.y NodeRotN.z NodeRotN.w to:File_Out
				format "%\n" (($.scale.x + $.scale.y + $.scale.z)/3) to:File_Out
			)
			else (
				in coordsys parent NodePos = $.pos
				in coordsys parent NodeRot = $.rotation
				NodeRotN = normalize (quat -NodeRot.x -NodeRot.y -NodeRot.z NodeRot.w)
				format "%\t%\t%\n" NodePos.x NodePos.y NodePos.z to:File_Out
				format "%\t%\t%\t%\n" NodeRotN.x NodeRotN.y NodeRotN.z NodeRotN.w to:File_Out
				format "%\n" (($.scale.x + $.scale.y + $.scale.z)/3) to:File_Out
			)
		)-- end for n to numnodes
		sliderTime += 1
	)--end for f to numframes
)--End write animation

fn BuildArrays =
(
	NodeArray = #()
	SelectedNodes = #()
	ParentArray = #()
	TempChildren = #()
	FirstChildIndexes = #()
	NextSiblingIndexes = #()
	ParentSort = 0
	NodesComplete = 1
	NameToTrim = ""
	NumNodes= 0

	clearSelection()
	select $'frame*'
	SelectedNodes = getcurrentselection()
	if SelectedNodes.count == 0 do (
		select $'Bip01*'
		SelectedNodes = getcurrentselection()
		)--end if SelectedNodes
		
	if SelectedNodes.count !=0 then( -- if it is not zero continue
		NumNodes = SelectedNodes.count
		StopCheck = 0
		for p = 1 to NumNodes do ( -- select scene root
			actionMan.executeAction 0 "40193"  
		) -- end for P to numNodes
		SelectedNodes = GetCurrentSelection()
		if SelectedNodes.count < 2 then(
			--Bake in the first node (root)
			$.name = parentSort as string + $.name
			parentSort +=1
			append NodeArray $.name
			
			--SelectChildren
			for c = 2 to NumNodes do(
				actionMan.executeAction 0 "40194"
				deselect $'#*' -- I Know..... It's bad...
				deselect $'1*'
				deselect $'2*' -- ...But it's also 2AM....
				deselect $'3*'
				deselect $'4*'
				deselect $'5*' -- ... And I'm Tired...
				deselect $'6*'
				deselect $'7*' -- ... And want to finish this script...
				deselect $'8*'
				deselect $'9*' -- ...So I do this...
				deselect $'0*' -- ...Can you guess why I do all of these?
				SelectedNodes = GetCurrentSelection()
				for n = 1 to SelectedNodes.count do (
					select SelectedNodes[n]
					$.name = parentSort as string + $.name
					NodeDone = findItem NodeArray $.name
					append NodeArray $.name
					)-- End for N to selectedNodes count
					ParentSort +=1
					Select SelectedNodes
				)--End for C to numnodes
				
			Sort NodeArray -- sort the way Tool likes
			
			--Get rid of leading numbers
			for f = 1 to NumNodes do(
			NodePath = getNodeByName NodeArray[f]
			Select NodePath
			$.name = trimLeft $.name "1234567890"
			NodeArray[f] = $.name
	
	
			)--End for f to numnodes
			for a = 1 to NumNodes do( -- once again for fixed names to be recorded
				NodePath = getNodeByName NodeArray[a]
				Select NodePath
				for p = 1 to $.children.count do (
					if substring $.children[p].name 1 1  != "#" do (
						append tempChildren (findItem NodeArray $.children[p].name)
						)
				)-- end for P to children count
				append ParentArray Tempchildren
				TempChildren = #()
			)-- end for A
			for c = 1 to NumNodes do ( -- time to build child and sibling indexes...
				NodePath = getNodeByName NodeArray[c]
				Select NodePath
				if $.children.count >= 1 then (
					TempChildIndex = findItem NodeArray $.children[1].name
					TempChildIndex = TempChildIndex - 1
					append FirstChildIndexes TempChildIndex 
				)
				else(
					append FirstChildIndexes "-1"
				)
				if c == 1 then (
					append NextSiblingIndexes "-1"
					)
				else (
					ParentIndex = findItem NodeArray $.parent.name
					if parentArray[ParentIndex].count == 0 then (
						append NextSiblingIndexes "-1"
					)
					else (
						NextSibling = FindItem parentArray[ParentIndex] c
						if NextSibling == parentArray[ParentIndex].count then (
							append NextSiblingIndexes "-1"
						)
						else(
							NextSiblingIndex = parentArray[ParentIndex][nextSibling +1]
							NextSiblingIndex = (NextSiblingIndex - 1)
							append NextSiblingIndexes NextSiblingIndex
							
						)
					)
				)
			) --- end for C to numnodes				
		)-- end if $.count > 1
		else (
			messageBox "There are too many actors to export" title:"Export error!"
			StopCheck = 1
		)-- End else

	)-- end if count !0
	else (
		messageBox "There are no actors to export" title:"Export error!"
		StopCheck = 1
	)-- End else
) -- End build arrays

-- Rollout stuff--
rollout ro_main "Halo Animation eXporter" Width:175 Height:175
(

	Group ""(
		label l_name "Halo Animation file eXporter" enabled:false
		Label l_name2 "By Tanasoo            v1.2B" enabled:False
		Label l_NLCheck "Node List Checksum:"
		edittext et_NLCheck "" FieldWidth:142
			RadioButtons ra_ExMode "Select Export Method:" 
				Labels:#("File", "Listener")default:1
		button b_Export "Export" tooltip:"Press to start exporting"
		)-- End of group
		
		on et_NLCheck changed text do (
			NLCheckSum = et_NLCheck.text
			)
		
		on b_Export pressed do(
		CurrentNode = 1
		if NLCheckSum != "" then(
			if  ra_ExMode.state == 1 then
			(
				SaveName = getSaveFileName types:"JMA (*.jma)|*.jma|JMO (*.jmo)|*.jmo|JMM (*.jmm)|*.jmm|JMR (*.jmr)|*.jmr|Text file (*.txt)|*.txt"
				if SaveName != undefined do(
					File_Out = createfile SaveName
					Print "Creating file..."
					BuildArrays()
					if stopCheck == 0 do(
						WriteHeader()
						WriteHierarchy()
						WriteAnimation()
						Print "File Created!"
						close File_Out
						messageBox "File sucessfully exported" title:"Export complete!"
						)
					)--end of if save
			)--End of if 2
				
			else 
			(
			clearListener()
			File_Out = listener
			BuildArrays()
			if stopCheck == 0 do(
				WriteHeader()
				WriteHierarchy()
				WriteAnimation()
				messageBox "File sucessfully exported" title:"Export complete!"
				)
			)
		)--end checksum check
		else(messageBox "Enter a Node List Checksum number" title:"Export error!")
		
		)-- End of on B_Export
		
)--End of RoMain



--Make Floater--
CreateDialog ro_main
)--End of script